(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('nthm', ['exports', '@angular/common', '@angular/core', '@angular/forms'], factory) :
    (global = global || self, factory(global.nthm = {}, global.ng.common, global.ng.core, global.ng.forms));
}(this, (function (exports, common, core, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * The ToggleLabel directive allows you to customize the label for the "On" and "Off" states,
     * allowing for more robust and complex displays.
     * This directive must be used in conjunction with a ng-template.
     */
    var NgToggleLabel = /** @class */ (function () {
        function NgToggleLabel(templateRef, elRef) {
            this.templateRef = templateRef;
            this.elRef = elRef;
        }
        Object.defineProperty(NgToggleLabel.prototype, "element", {
            get: function () {
                return this.elRef;
            },
            enumerable: true,
            configurable: true
        });
        NgToggleLabel.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggleLabel.prototype, "forLabel", void 0);
        NgToggleLabel = __decorate([
            core.Directive({ selector: 'ng-template[ngToggleLabel]' }),
            __metadata("design:paramtypes", [core.TemplateRef, core.ElementRef])
        ], NgToggleLabel);
        return NgToggleLabel;
    }());

    /**
     * The Toggle directive allows for standalone or checkbox-enabled switch toggling via a UI element.
     * The toggle is styled using Bootstrap v4+ classes.
     * Accessibility implemented according to
     * https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA/Roles/checkbox_role
     */
    var NgToggle = /** @class */ (function () {
        function NgToggle(ngZone, element) {
            this.ngZone = ngZone;
            this.element = element;
            /**
             * Display text when toggled in the "On" position
             */
            this.onText = 'On';
            /**
             * Display text when toggled in the "Off" position
             */
            this.offText = 'Off';
            /**
             * Bootstrap color scheme when toggled in the "On" position (i.e. "primary" translates to "btn-primary")
             */
            this.onColor = 'primary';
            /**
             * Bootstrap color scheme when toggled in the "Off" position (i.e. "primary" translates to "btn-primary")
             */
            this.offColor = 'secondary';
            /**
             * Button size to display the toggle
             */
            this.size = '';
            /**
             * Whether the toggle is disabled or not
             */
            this.disabled = false;
            /**
             * An event fired when the user causes a change.
             * The payload of the event is the currently selected value.
             */
            this.valueChange = new core.EventEmitter();
            this.btnClass = true;
            this.tabindex = 0;
            this.role = 'checkbox';
            this.width = 0;
            this.handleWidth = 0;
            this._animate = true;
            this._innerAnimate = true;
            this._innerState = false;
            this._innerWidth = 'auto';
            this._disableInitialAnimation = false;
            this._dragStart = null;
            this._dragEnd = null;
            this._initialized = false;
            this._hidden = false;
        }
        Object.defineProperty(NgToggle.prototype, "outerAnimate", {
            /**
             * Optional. Enable/Disable the initial transition animation. May prevent unwanted animation display.
             */
            set: function (value) {
                this._disableInitialAnimation = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "value", {
            get: function () {
                return this._innerState;
            },
            set: function (value) {
                this.setState(value);
            },
            enumerable: true,
            configurable: true
        });
        NgToggle.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.calculateWidth();
            this._initialized = true;
            this.ngZone.run(function () { return setTimeout(function () { return _this._disableInitialAnimation = false; }); });
        };
        NgToggle.prototype.ngAfterViewChecked = function () {
            var hidden = this.element.nativeElement.offsetParent === null;
            if ((!this._initialized || this.width === 0) && this._hidden !== hidden) {
                this._initialized = false;
                this.calculateWidth();
                this._initialized = true;
            }
            this._hidden = hidden;
        };
        NgToggle.prototype.ngAfterContentInit = function () {
            var onElement = this.labelElements.find(function (item) { return item.forLabel.toLowerCase() === 'on'; });
            var offElement = this.labelElements.find(function (item) { return item.forLabel.toLowerCase() === 'off'; });
            if (onElement) {
                this.onLabel = onElement;
            }
            if (offElement) {
                this.offLabel = offElement;
            }
            if (onElement || offElement) {
                this.calculateWidth(true);
            }
        };
        NgToggle.prototype.ngOnChanges = function (changes) {
            if ('onText' in changes || 'offText' in changes || 'size' in changes) {
                this._initialized = false;
                this.calculateWidth(this._initialized);
                this._initialized = true;
            }
        };
        Object.defineProperty(NgToggle.prototype, "largeButton", {
            get: function () {
                return this.size === 'lg';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "smallButton", {
            get: function () {
                return this.size === 'sm';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "handleDark", {
            get: function () {
                return (this.value && this.onColor === 'light') || (!this.value && this.offColor === 'light');
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "indeterminate", {
            get: function () {
                return this._innerState === null || typeof this._innerState === 'undefined';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "toggledOn", {
            get: function () {
                return this.innerState === true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "toggledOff", {
            get: function () {
                return this.innerState === false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "innerState", {
            get: function () {
                return this._innerState;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "ariaCheckedValue", {
            get: function () {
                if (this.indeterminate) {
                    return 'mixed';
                }
                return this.value ? 'true' : 'false';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "animate", {
            get: function () {
                return this._animate && (!this._disableInitialAnimation || this._initialized && !this._disableInitialAnimation);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "marginLeft", {
            get: function () {
                var margin = 0;
                if (!this._initialized) {
                }
                else if (this.indeterminate || this._innerState === null || typeof this._innerState === 'undefined') {
                    margin = -(this.width / 2);
                }
                else if (this._dragEnd) {
                    margin = this._dragEnd;
                }
                else if (!this._innerState) {
                    margin = -this.width;
                }
                return margin + 'px';
            },
            enumerable: true,
            configurable: true
        });
        NgToggle.prototype.handleResize = function () {
            this._initialized = false;
            this.calculateWidth(true);
            this._initialized = true;
        };
        NgToggle.prototype.handleClick = function () {
            if (!this.disabled && !this._dragEnd) {
                this.setState(!this._innerState);
            }
            else if (this._dragEnd) {
                this._dragEnd = null;
            }
        };
        NgToggle.prototype.onTouchStart = function (event) {
            this.onDragStart(event);
        };
        NgToggle.prototype.onMouseDown = function (event) {
            this.onDragStart(event);
        };
        NgToggle.prototype.onTouchMove = function (event) {
            this.onDragMove(event);
        };
        NgToggle.prototype.onMouseMove = function (event) {
            this.onDragMove(event);
        };
        NgToggle.prototype.onTouchEnd = function (event) {
            this.onDragEnd(event, true);
        };
        NgToggle.prototype.onMouseUp = function (event) {
            this.onDragEnd(event);
        };
        NgToggle.prototype.onMouseLeave = function (event) {
            this.onDragEnd(event, true);
        };
        NgToggle.prototype.onKeyDown = function (event) {
            if (!event.key || this.disabled) {
                return;
            }
            switch (event.key) {
                case 'Left':
                case 'ArrowLeft':
                    event.preventDefault();
                    event.stopImmediatePropagation();
                    this.setState(false);
                    break;
                case 'Right':
                case 'ArrowRight':
                    event.preventDefault();
                    event.stopImmediatePropagation();
                    this.setState(true);
                    break;
                case 'Spacebar':
                case ' ':
                    event.preventDefault();
                    event.stopImmediatePropagation();
                    this.setState(!this.value);
            }
        };
        NgToggle.prototype.onDragStart = function (event) {
            if (event.target === this.handle$) {
                if (this._dragStart || this.disabled) {
                    return;
                }
                event.preventDefault();
                event.stopPropagation();
                this._dragStart = (event.pageX || event.touches[0].pageX) - parseInt(this.container$.style.marginLeft, 10);
                if (this._animate) {
                    this._animate = !this._animate;
                }
            }
        };
        NgToggle.prototype.onDragMove = function (event) {
            if (this._dragStart) {
                event.preventDefault();
                var difference = (event.pageX || event.touches[0].pageX) - this._dragStart;
                if (difference < -(Number(this.width)) || difference > 0) {
                    return;
                }
                this._dragEnd = difference;
            }
        };
        NgToggle.prototype.onDragEnd = function (event, clearDragEnd) {
            if (clearDragEnd === void 0) { clearDragEnd = false; }
            if (this._dragStart) {
                event.preventDefault();
                event.stopPropagation();
                if (this._dragEnd) {
                    this.setState(this._dragEnd > -(Number(this.width) / 2));
                }
                this._dragStart = null;
                if (clearDragEnd) {
                    this._dragEnd = null;
                }
                if (this._innerAnimate && !this._animate) {
                    this._animate = true;
                }
            }
        };
        NgToggle.prototype.calculateWidth = function (disableAnimation) {
            var _this = this;
            if (disableAnimation === void 0) { disableAnimation = false; }
            if (disableAnimation && this._innerAnimate) {
                this._animate = false;
            }
            var initialized = this._initialized;
            if (!initialized) {
                this.container$.style.width = 'auto';
                this.element$.style.width = 'auto';
            }
            this.on$.style.width = 'auto';
            this.off$.style.width = 'auto';
            setTimeout(function () {
                var width = _this._innerWidth;
                if (_this._innerWidth === 'auto') {
                    width = Math.max(_this.on$.offsetWidth, _this.off$.offsetWidth);
                }
                _this.handleWidth = _this.handle$.offsetWidth;
                _this.width = Number(width);
                if (!initialized) {
                    _this.container$.style.width = ((_this.width * 2) + _this.handleWidth) + 'px';
                    _this.element$.style.width = (_this.width + _this.handleWidth) + 'px';
                }
                _this.ngZone.run(function () {
                    _this.on$.style.width = _this.width + 'px';
                    _this.off$.style.width = _this.width + 'px';
                    setTimeout(function () {
                        if (disableAnimation && _this._innerAnimate) {
                            _this._animate = true;
                        }
                    });
                });
            });
        };
        NgToggle.prototype.setState = function (value) {
            if (value !== this._innerState) {
                this._innerState = value;
                this.valueChange.emit(this._innerState);
            }
        };
        Object.defineProperty(NgToggle.prototype, "element$", {
            get: function () {
                return this.element.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "on$", {
            get: function () {
                return this.onElement.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "off$", {
            get: function () {
                return this.offElement.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "handle$", {
            get: function () {
                return this.handleElement.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgToggle.prototype, "container$", {
            get: function () {
                return this.containerElement.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        NgToggle.ctorParameters = function () { return [
            { type: core.NgZone },
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggle.prototype, "onText", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggle.prototype, "offText", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggle.prototype, "onColor", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggle.prototype, "offColor", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], NgToggle.prototype, "size", void 0);
        __decorate([
            core.Input(), core.HostBinding('class.disabled'), core.HostBinding('class.ng-toggle-disabled'),
            __metadata("design:type", Boolean)
        ], NgToggle.prototype, "disabled", void 0);
        __decorate([
            core.Input('disableInitialAnimation'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [Boolean])
        ], NgToggle.prototype, "outerAnimate", null);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [Boolean])
        ], NgToggle.prototype, "value", null);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], NgToggle.prototype, "valueChange", void 0);
        __decorate([
            core.HostBinding('class.btn'),
            __metadata("design:type", Boolean)
        ], NgToggle.prototype, "btnClass", void 0);
        __decorate([
            core.Input('tabindex'), core.HostBinding('attr.tabindex'),
            __metadata("design:type", Number)
        ], NgToggle.prototype, "tabindex", void 0);
        __decorate([
            core.Input('role'), core.HostBinding('attr.role'),
            __metadata("design:type", Object)
        ], NgToggle.prototype, "role", void 0);
        __decorate([
            core.ViewChild('container', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], NgToggle.prototype, "containerElement", void 0);
        __decorate([
            core.ViewChild('on', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], NgToggle.prototype, "onElement", void 0);
        __decorate([
            core.ViewChild('off', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], NgToggle.prototype, "offElement", void 0);
        __decorate([
            core.ViewChild('handle', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], NgToggle.prototype, "handleElement", void 0);
        __decorate([
            core.ContentChildren(NgToggleLabel),
            __metadata("design:type", core.QueryList)
        ], NgToggle.prototype, "labelElements", void 0);
        __decorate([
            core.HostBinding('class.btn-lg'),
            core.HostBinding('class.ng-toggle-lg'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "largeButton", null);
        __decorate([
            core.HostBinding('class.btn-sm'),
            core.HostBinding('class.ng-toggle-sm'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "smallButton", null);
        __decorate([
            core.HostBinding('class.ng-toggle-indeterminate'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "indeterminate", null);
        __decorate([
            core.HostBinding('class.ng-toggled-on'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "toggledOn", null);
        __decorate([
            core.HostBinding('class.ng-toggled-off'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "toggledOff", null);
        __decorate([
            core.HostBinding('attr.aria-checked'),
            __metadata("design:type", String),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "ariaCheckedValue", null);
        __decorate([
            core.HostBinding('class.ng-toggle-animate'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], NgToggle.prototype, "animate", null);
        __decorate([
            core.HostListener('window:resize'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "handleResize", null);
        __decorate([
            core.HostListener('click'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "handleClick", null);
        __decorate([
            core.HostListener('touchstart', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onTouchStart", null);
        __decorate([
            core.HostListener('mousedown', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onMouseDown", null);
        __decorate([
            core.HostListener('touchmove', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onTouchMove", null);
        __decorate([
            core.HostListener('mousemove', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onMouseMove", null);
        __decorate([
            core.HostListener('touchend', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onTouchEnd", null);
        __decorate([
            core.HostListener('mouseup', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onMouseUp", null);
        __decorate([
            core.HostListener('mouseleave', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onMouseLeave", null);
        __decorate([
            core.HostListener('keydown', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [KeyboardEvent]),
            __metadata("design:returntype", void 0)
        ], NgToggle.prototype, "onKeyDown", null);
        NgToggle = __decorate([
            core.Component({
                selector: 'ng-toggle',
                template: "\n    <span #container class=\"ng-toggle-container\" [style.marginLeft]=\"marginLeft\">\n      <span #on class=\"ng-toggle-on btn btn-{{onColor}}\" [class.btn-lg]=\"largeButton\"\n            [class.btn-sm]=\"smallButton\" [class.disabled]=\"disabled\">\n          <ng-template [ngTemplateOutlet]=\"onLabel?.templateRef\"></ng-template>\n          <ng-container *ngIf=\"!onLabel\">{{onText}}</ng-container>\n      </span>\n      <span #handle class=\"ng-toggle-handle btn\" [class.btn-lg]=\"largeButton\"\n            [class.btn-sm]=\"smallButton\" [class.disabled]=\"disabled\"\n            [class.btn-light]=\"!handleDark\" [class.btn-dark]=\"handleDark\">&nbsp;</span>\n      <span #off class=\"ng-toggle-off btn btn-{{offColor}}\" [class.btn-lg]=\"largeButton\"\n            [class.btn-sm]=\"smallButton\" [class.disabled]=\"disabled\">\n        <ng-template [ngTemplateOutlet]=\"offLabel?.templateRef\"></ng-template>\n        <ng-container *ngIf=\"!offLabel\">{{offText}}</ng-container>\n      </span>\n    </span>\n    <ng-content></ng-content>\n    ",
                preserveWhitespaces: false,
                encapsulation: core.ViewEncapsulation.None,
                styles: ["ng-toggle{position:relative;display:inline-block;direction:ltr;cursor:pointer;overflow:hidden;padding:0!important;text-align:left;z-index:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;vertical-align:middle;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;box-sizing:content-box}ng-toggle.disabled,ng-toggle.disabled .btn{cursor:default}ng-toggle input{position:absolute;z-index:-1;visibility:hidden;width:1px;height:1px}ng-toggle .ng-toggle-container,ng-toggle .ng-toggle-handle,ng-toggle .ng-toggle-off,ng-toggle .ng-toggle-on{display:-ms-flexbox!important;display:flex!important}ng-toggle .ng-toggle-container{-ms-flex-align:stretch!important;align-items:stretch!important;top:0;border-radius:0;-webkit-transform:translateZ(0);transform:translateZ(0)}ng-toggle.ng-toggle-animate .ng-toggle-container{transition:margin-left .5s}ng-toggle .ng-toggle-off,ng-toggle .ng-toggle-on{-ms-flex-align:center!important;align-items:center!important;text-align:center;z-index:1;border-radius:0}ng-toggle .ng-toggle-handle,ng-toggle .ng-toggle-off,ng-toggle .ng-toggle-on{box-sizing:border-box;cursor:pointer;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}ng-toggle .ng-toggle-handle{text-align:center;margin-top:-1px;margin-bottom:-1px;z-index:100;width:1em;padding-left:0;padding-right:0;-ms-flex-item-align:stretch!important;-ms-grid-row-align:stretch!important;align-self:stretch!important}"]
            }),
            __metadata("design:paramtypes", [core.NgZone, core.ElementRef])
        ], NgToggle);
        return NgToggle;
    }());

    var NgToggleAccessor = /** @class */ (function () {
        function NgToggleAccessor(_host) {
            var _this = this;
            this._host = _host;
            this._subscription = this._host.valueChange.subscribe(function (value) { return _this.onChange(value); });
        }
        NgToggleAccessor_1 = NgToggleAccessor;
        NgToggleAccessor.prototype.ngOnDestroy = function () {
            if (this._subscription) {
                this._subscription.unsubscribe();
                this._subscription = null;
            }
        };
        NgToggleAccessor.prototype.onChange = function (_) {
            if (this._onChange) {
                this._onChange(this._host.value);
            }
        };
        NgToggleAccessor.prototype.onTouched = function () {
            if (this._onTouched) {
                this._onTouched();
            }
        };
        NgToggleAccessor.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NgToggleAccessor.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NgToggleAccessor.prototype.setDisabledState = function (isDisabled) {
            this._host.disabled = isDisabled;
        };
        NgToggleAccessor.prototype.writeValue = function (obj) {
            if (typeof obj === 'boolean' || obj === null) {
                this._host.value = obj;
            }
        };
        var NgToggleAccessor_1;
        NgToggleAccessor.ctorParameters = function () { return [
            { type: NgToggle }
        ]; };
        NgToggleAccessor = NgToggleAccessor_1 = __decorate([
            core.Directive({
                selector: 'ng-toggle',
                host: { '(change)': 'onChange($event)', '(touch)': 'onTouched()' },
                providers: [{ provide: forms.NG_VALUE_ACCESSOR, useExisting: core.forwardRef(function () { return NgToggleAccessor_1; }), multi: true }]
            }),
            __metadata("design:paramtypes", [NgToggle])
        ], NgToggleAccessor);
        return NgToggleAccessor;
    }());

    var declarations = [
        NgToggle,
        NgToggleAccessor,
        NgToggleLabel,
    ];
    var NgToggleModule = /** @class */ (function () {
        function NgToggleModule() {
        }
        NgToggleModule = __decorate([
            core.NgModule({ imports: [common.CommonModule], exports: declarations, declarations: declarations })
        ], NgToggleModule);
        return NgToggleModule;
    }());

    exports.NgToggle = NgToggle;
    exports.NgToggleAccessor = NgToggleAccessor;
    exports.NgToggleLabel = NgToggleLabel;
    exports.NgToggleModule = NgToggleModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-toggle.umd.js.map
